'***************************************************************************************
'*                                                                                     *
'*  Ganganzeige Rev. V3 by Ati mit einem Open-Mini                                     *
'*  Softwarestand V3.3                                                                 *
'*                                                                                     *
'***************************************************************************************

' Ganganzeige mit integrierter Scheinwerfersteuerung und LED-Anzeige-Helligkeitssteuerung
' Dazu wird das Gangsensorsignal, die Umgebungshelligkeit und das Kurbelwellenpositionssensorsignal ausgewertet
' und einem integriertem Schaltblitz
' Nachts krzere Blitzdauer als bei Tageshelligkeit. Steuerung durch die Umgebungshelligkeit
' Alle LEDs werden ber PWM durch die Umgebungshelligkeit gesteuert
' Scheinwerfereinschaltung erfolgt bei Motordrehzahl grer 700 U/min
' Drehzahlermittlung durch Kurbelwellenpositionssensor (Suzuki SV1000s/SV650S/SV1000/SV650 22 Impulse je Umdrehung)

' Gangabfrage nur jeden x.ten Programmdurchlauf um Die Anzeigeumschaltung zu verzgern
' Gangwiederholzhler zur Unterdrckung vom Ziffersprgen (derzeit 180 ms Umlauf innerhalb der Anzeige bis Umschalten der Ganganzeige)

' --- Betriebssystem konfigurieren ------------------------------------------
include "om.def"           ' Definitionen fuer Betriebssystem
option openmini
RunOnErr = on              ' bei Fehler Programm neustarten (Fehler in ERR)
pullupa = 0
pullupb = 0
ClockDis = on
' ---------------------------------------------------------------------------
'--- Definitionen der QT4 & QY4 Ports --------------------------------------------------
define Sensor3        ad[6]             'Eingang Sensor Umgebungshelligkeit
define Sensor1        ad[5]             'Eingang Sensor Gang
'define Sensor2      port[3]             'host/run und Sensor Drehzahl
define a            port[2]             'Ausgang a
define b            port[11]            'Ausgang b
define c            port[12]            'Ausgang c
define d            port[4]             'Ausgang d
define e            port[13]            'Ausgang e
define f            port[14]            'Ausgang f
define g            port[9]             'Ausgang g
define dp           port[15]            'Ausgang Dezimalpunkt und Lichtsteuerung
define PWM_Port     port[1]             '1. PWM Ausgang
define Relais       port[10]            'Relaissteuerausgang
define Schaltblitz  port[16]            'Schaltblitzausgang
define tmp          byte                ' Hilfsvariable fr PWM
define k            byte                ' Gangvariable
define l1           byte                ' Gangdurchlaufzhlervariable
define x            byte                ' Timervariable
define dl           byte                ' Durchlaufvariable
define x1           byte                ' Gangzhler1
define x2           byte                ' Gangzhler2
define x3           byte                ' Gangzhler3
define x4           byte                ' Gangzhler4
define x5           byte                ' Gangzhler5
define x6           byte                ' Gangzhler6
define xF           byte                ' Fehlervariable
define xL           byte                ' Leerlaufvariable
define y            byte                ' Zhlervariable Ende-Timer
define p            byte                ' Variable fr PWM
define z            byte                ' Variable fr Frequenzmessung
define bl           byte                ' Variable fr Schaltblitzwiederholung

'   Die Pinbelegung der
'    Open-Mini (QY4)     _____    _____
'                       |     \__/     |
'                      [  VDD      GND  ]       VDD = 4.6 bis 5.5 Volt
'                       |              |
'      Schaltblitz  16 [  PTB7    PTB0  ] 9     g
'                       |              |
'              dp   15 [  PTB6    PTB1  ] 10    Lichtrelais
'                       |              |
'      Lichtsensor   6 [  PTA5    PTA0  ] 1     PWM1
'                       |              |
'      Sensor Gang   5 [  PTA4    PTA1  ] 2     a
'                       |              |
'               f   14 [  PTB5    PTB2  ] 11    b
'                       |              |
'               e   13 [  PTB4    PTB3  ] 12    c
'                       |
'               d    4 [  PTA3    PTA2  ] 3     host/run Frequenzmessung
'                       |______________|
'

'--- Variablen -------------------------------------------------------------------------
tmp = 0                                    ' Wertvariable fr PWM
k = 0                                      ' Variable fr Gang
l1 = 0                                      ' Gangdurchlaufzhlervariable Hauptprogramm auf drei Umlufe setzen
x = 0                                      ' Variable fr Timer
dl = 3                                     ' Variable fr Anzahl Durchlufe bis zur Ganganzeige
x1 = 0                                     ' Variable Gangzhler 1 auf 0
x2 = 0                                     ' Variable Gangzhler 2 auf 0
x3 = 0                                     ' Variable Gangzhler 3 auf 0
x4 = 0                                     ' Variable Gangzhler 4 auf 0
x5 = 0                                     ' Variable Gangzhler 5 auf 0
x6 = 0                                     ' Variable Gangzhler 6 auf 0
xF = 0                                     ' Variable Fehleranzeige auf 0
xL = 0                                     ' Variable Leerlaufanzeige auf 0
y = 0                                      ' Variable fr zweiten Timer
p = 0                                      ' Variable fr PWM
z = 0                                      ' Variable fr Frequenzmessung
bl = 0                                     ' Blitzwiederholungszhler
'---------------------------------------------------------------------------------------

'--- Initialisierung Hard und Software -------------------------------------------------
' Es werden jetzt kurz eine 8 gezeigt, dann kreisen die ueren Balken und dann werden die Zahlen 0 bis 6 angezeigt.
' Danach begint dass eigentliche Programm.
'--------------------
pwm1_ein                                        ' Einschalten des PWM
tmp = 250                                       ' LED-Helligkeit 100%
pwm1 tmp                                        ' Datenzuweisung fr PWM1
Initial                                         ' Anzeige auf- und abschwellende 8 auf dem Display
Display_init                                    ' kreisende Balken
Leerlaufinit : pause 8                              ' Anzeige 0 auf dem Display
Gang_1init : pause 8                                ' Anzeige 1 auf dem Display
Gang_2init : pause 8                                ' Anzeige 2 auf dem Display
Gang_3init : pause 8                                ' Anzeige 3 auf dem Display
Gang_4init : pause 8                                ' Anzeige 4 auf dem Display
Gang_5init : pause 8                                ' Anzeige 5 auf dem Display
Gang_6init : pause 8                                ' Anzeige 6 auf dem Display
Fehlerinit : pause 8                                ' Anzeige E auf dem Display
Blitznacht
pause 6
Blitznacht
pause 6
Blitztag
'---------------------------------------------------------------------------------------

'--- Hauptprogramm ---------------------------------------------------------------------
' Es werden nun alle 0,06 Sekunden die Sensoren abgefragt.
'--------------------
#start
'Programmanfang
'Gangkontrolle
#Gangkontrolle
  l1 = l1+1                                     ' Umlaufzhler fr Gangabfage - nur jeder dritte Umlauf
  if l1 = 3 then
  goto GangkontrolleZ                           ' Sprung zur Gangabfrage
#Gangkontrolle1
  l1 = 0                                        ' Rcksetzen Gangabfragezhler
  end if

'Lichtkontrolle
freq = 3                                        ' Torzeit 0,06 Sekunden
z = freq                                        ' bernahme des Impulszhler-Messwertes
if z > 15 then
     gosub Licht_on                             ' Drehzahl grer ca. 700 U/min (Anlasserdrehzahl ca. 160 U/min) = 257 Hz
else if z <= 14 then
     gosub Licht_off                            ' Drehzahl kleiner ca. 700 U/min
end if
'Schaltblitz
'if z>=52 and k=0 then goto setz1                ' Blitztest Drehzahl 2500 U/min erreicht und Leerlauf? Ja, dann setze EIN-Flanke und Blitze = 875 Hz
if z>=189 and k=5 then goto setz1               ' Drehzahl 9000 U/min erreicht und 5. Gang? Ja, dann setze EIN-Flanke und Blitze = 3150 Hz
if z>=184 and k=4 then goto setz1               ' Drehzahl 8800 U/min erreicht und 4. Gang? Ja, dann setze EIN-Flanke und Blitze = 3080 Hz
if z>=181 and k=3 then goto setz1               ' Drehzahl 8600 U/min erreicht und 3. Gang? Ja, dann setze EIN-Flanke und Blitze = 3010 Hz
if z>=176 and k=2 then goto setz1               ' Drehzahl 8400 U/min erreicht und 2. Gang? Ja, dann setze EIN-Flanke und Blitze = 2940 Hz
if z>=172 and k=1 then goto setz1               ' Drehzahl 8200 U/min erreicht und 1. Gang? Ja, dann setze EIN-Flanke und Blitze = 2870 Hz
goto weiter
#setz1
bl = bl + 1                                     ' Wiederholungszhler
if bl = 20 then setz2                           ' Wiederholungszhlerabfrage - Lschen Blitzwiederholungsflag
goto weiter                                     ' Wiederholungsunterdrckung
#setz2
if Sensor3<=105 then gosub Blitznacht           ' Blitzen bei Dunkelheit
if Sensor3>105 then gosub Blitztag              ' Blitzen bei Helligkeit
bl = 0                                          ' Lsche Wiederholungszhler
#weiter
'Umgebungshelligkeit
if Sensor3<=105 then
     tmp = 40                                   'Anzeige - dunkelleuchtend
else if Sensor3>=106 and Sensor3<=119 then
     tmp = 60                                   'Anzeige - heller1
else if Sensor3>=120 and Sensor3<=132 then
     tmp = 80                                   'Anzeige - heller2
else if Sensor3>=133 and Sensor3<=144 then
     tmp = 100                                  'Anzeige - heller3
else if Sensor3>=145 and Sensor3<=156 then
     tmp = 120                                  'Anzeige - heller4
else if Sensor3>=157 and Sensor3<=170 then
     tmp = 140                                  'Anzeige - heller5
else if Sensor3>=171 and Sensor3<=182 then
     tmp = 160                                  'Anzeige - heller6
else if Sensor3>=183 and Sensor3<=195 then
     tmp = 180                                  'Anzeige - heller7
else if Sensor3>=196 and Sensor3<=208 then
     tmp = 200                                  'Anzeige - heller8
else if Sensor3>=209 and Sensor3<=222 then
     tmp = 230                                  'Anzeige - heller9
else if Sensor3>=223 then
     tmp = 250                                  'Anzeige - ganz hell
end if
pwm1 tmp
                                                'Wartezeit fr neue Abfragen
pause 3 				        'Pause 60 Millisekunden
goto start                                      'zum Programmanfang
'---------------------------------------------------------------------------------------

'--- Display init -----------------------------------------------------------------------
' die ueren Balkensegmente kreisen im Uhrzeigersinn
'--------------------
FUNC Display_init
x = Timer                                       ' setzt X auf Timer, Timer zhlt automatisch hoch
y = Timer                                       ' setzt X auf Timer, Timer zhlt automatisch hoch
#schleife
if Timer = x then dp = on                       ' Dezimalpunkt einschalten
if Timer = x then a = on
if Timer = x then f = off                       ' Segment f aus
if Timer = x + 4 then b = on                    ' Balken b nach 0,16 Sekunden
if Timer = x + 4 then a = off                   ' Balken a aus nach 0,16 Sekunden
if Timer = x + 4 then dp = off
if Timer = x + 8 then c = on                    ' Balken c  usw.
if Timer = x + 8 then dp = on
if Timer = x + 8 then b = off
if Timer = x + 12 then d = on
if Timer = x + 12 then c = off
if Timer = x + 12 then dp = off
if Timer = x + 16 then e = on
if Timer = x + 16 then dp = on
if Timer = x + 16 then d = off
if Timer = x + 20 then f = on
if Timer = x + 20 then e = off
if Timer = x + 20 then dp = off
if Timer = x + 24 then x = timer                ' 1. Timer Neustart
if Timer = y + 48 then goto weiter1             ' 2. Timer zhlt hoch - Dauer der Umlufe
goto schleife                                   ' sind nicht alle Durchlufe absolviert, dann von vorn
#weiter1
f = off
dp = off
RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Fehler Init------------------------------------------------------------------------
' es wird ein E angezeigt
' -------------------
FUNC Fehlerinit
  a = on
  b = off
  c = off
  d = on
  e = on
  f = on
  g = on
  Return
End FUNC
'------------------------------------------------------------------------------

'--- Leerlauf Init------------------------------------------------------------------
' Es wird eine 0 auf dem Display angezeigt.
'--------------------
FUNC Leerlaufinit
  k = 0
  a = on
  b = on
  c = on
  d = on
  e = on
  f = on
  g = off
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 1 Init----------------------------------------------------------------------------
' Es wird eine 1 auf dem Display angezeigt.
'--------------------
FUNC Gang_1init
  k = 1
  a = off
  b = on
  c = on
  d = off
  e = off
  f = off
  g = off
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Gang 2 Init----------------------------------------------------------------------------
' Es wird eine 2 auf dem Display angezeigt.
'--------------------
FUNC Gang_2init
  k = 2
  a = on
  b = on
  c = off
  d = on
  e = on
  f = off
  g = on
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Gang 3 Init----------------------------------------------------------------------------
' Es wird eine 3 auf dem Display angezeigt.
'--------------------
FUNC Gang_3init
  k = 3
  a = on
  b = on
  c = on
  d = on
  e = off
  f = off
  g = on
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Gang 4 Init----------------------------------------------------------------------------
' Es wird eine 4 auf dem Display angezeigt.
'--------------------
FUNC Gang_4init
  k = 4
  a = off
  b = on
  c = on
  d = off
  e = off
  f = on
  g = on
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Gang 5 Init----------------------------------------------------------------------------
' Es wird eine 5 auf dem Display angezeigt.
'--------------------
FUNC Gang_5init
  k = 5
  a = on
  b = off
  c = on
  d = on
  e = off
  f = on
  g = on
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Gang 6 Init----------------------------------------------------------------------------
' Es wird eine 6 auf dem Display angezeigt.
'--------------------
FUNC Gang_6init
  k = 6
  a = on
  b = off
  c = on
  d = on
  e = on
  f = on
  g = on
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Subroutinen vom Hauptprogramm --------------------------------------------------------

'--- Unterprogramm Gangkontrolle---------------------------------------------------------
#GangkontrolleZ
if Sensor1>=0 and Sensor1<=69 then goto Fehler                                  'Anzeige - Error
#Error_return
if Sensor1>=70 and Sensor1<=103 then goto Gang_1                                'Anzeige - Gang 1 Sensorspannung am Pin von 1,42 - 2,06 Volt
#Gang_1_return
if Sensor1>=104 and Sensor1<=145 then goto Gang_2                               'Anzeige - Gang 2 Sensorspannung am Pin von 2,08 - 2,9 Volt
#Gang_2_return
if Sensor1>=146 and Sensor1<=179 then goto Gang_3                               'Anzeige - Gang 3 Sensorspannung am Pin von 2,92 - 3,54 Volt
#Gang_3_return
if Sensor1>=180 and Sensor1<=210 then goto Gang_4                               'Anzeige - Gang 4 Sensorspannung am Pin 3,56 -  4,20 Volt
#Gang_4_return
if Sensor1>=211 and Sensor1<=228 then goto Gang_5                               'Anzeige - Gang 5 Sensorspannung am Pin 4,22 - 4,56 Volt
#Gang_5_return
if Sensor1>=229 and Sensor1<=243 then goto Gang_6                               'Anzeige - Gang 6 Sensorspannung am Pin 4,58 - 4,86 Volt
#Gang_6_return
if Sensor1>=244 then goto Leerlauf                                              'Anzeige - Leerlauf Sensorspannung am Pin >4,92 Volt
#Leerlauf_return
goto Gangkontrolle1
'----------------------------------------------------------------------------------------

'--- Leerlauf --------------------------------------------------------------------------
' Es wird eine 0 auf dem Display angezeigt.
'--------------------
#Leerlauf
  xL = xL+1
  if xL = dl then
  k = 0
  a = on
  b = on
  c = on
  d = on
  e = on
  f = on
  g = off
  Gosub Ruecksetzen
  end if
  Goto Leerlauf_return
'---------------------------------------------------------------------------------------

'--- Gang 1 ----------------------------------------------------------------------------
' Es wird eine 1 auf dem Display angezeigt.
'--------------------
#Gang_1
  x1 = x1+1
  if x1 = dl then
  k = 1
  a = off
  b = on
  c = on
  d = off
  e = off
  f = off
  g = off
  Gosub Ruecksetzen
  end if
  Goto Gang_1_return
'---------------------------------------------------------------------------------------

'--- Gang 2 ----------------------------------------------------------------------------
' Es wird eine 2 auf dem Display angezeigt.
'--------------------
#Gang_2
  x2 = x2+1
  if x2 = dl then
  k = 2
  a = on
  b = on
  c = off
  d = on
  e = on
  f = off
  g = on
  Gosub Ruecksetzen
  end if
  Goto Gang_2_return
'---------------------------------------------------------------------------------------

'--- Gang 3 ----------------------------------------------------------------------------
' Es wird eine 3 auf dem Display angezeigt.
'--------------------
#Gang_3
  x3 = x3+1
  if x3 = dl then
  k = 3
  a = on
  b = on
  c = on
  d = on
  e = off
  f = off
  g = on
  Gosub Ruecksetzen
  end if
  Goto Gang_3_return
'---------------------------------------------------------------------------------------

'--- Gang 4 ----------------------------------------------------------------------------
' Es wird eine 4 auf dem Display angezeigt.
'--------------------
#Gang_4
  x4 = x4+1
  if x4 = dl then
  k = 4
  a = off
  b = on
  c = on
  d = off
  e = off
  f = on
  g = on
  Gosub Ruecksetzen
  end if
  Goto Gang_4_return
'---------------------------------------------------------------------------------------

'--- Gang 5 ----------------------------------------------------------------------------
' Es wird eine 5 auf dem Display angezeigt.
'--------------------
#Gang_5
  x5 = x5+1
  if x5 = dl then
  k = 5
  a = on
  b = off
  c = on
  d = on
  e = off
  f = on
  g = on
  Gosub Ruecksetzen
  end if
  Goto Gang_5_return
'---------------------------------------------------------------------------------------

'--- Gang 6 ----------------------------------------------------------------------------
' Es wird eine 6 auf dem Display angezeigt.
'--------------------
#Gang_6
  x6 = x6+1
  if x6 = dl then
  k = 6
  a = on
  b = off
  c = on
  d = on
  e = on
  f = on
  g = on
  Gosub Ruecksetzen
  end if
  Goto Gang_6_return
'---------------------------------------------------------------------------------------

'--- Fehler ----------------------------------------------------------------------------
' Es wird ein E fr Error auf dem Display angezeigt
'--------------------
#Fehler
  xF = xF+1
  if xF = dl then
  a = on
  b = off
  c = off
  d = on
  e = on
  f = on
  g = on
  Gosub Ruecksetzen
  end if
  Goto error_return
'---------------------------------------------------------------------------------------

'--- alle Gangvariablen auf Null setzen ---------------------------------------------------
  Func Ruecksetzen
  x1 = 0
  x2 = 0
  x3 = 0
  x4 = 0
  x5 = 0
  x6 = 0
  xF = 0
  xL = 0
  Return
  End Func
'------------------------------------------------------------------------------------------

'---Initialisierung---------------------------------------------------------------------
' Es wird eine auf- und abschwellende 8 auf dem Display angezeigt.
'-------------------
FUNC Initial
  k = 0
  a = on
  b = on
  c = on
  d = on
  e = on
  f = on
  g = on
x = Timer                                       ' setzt X auf Timer, Timer zhlt automatisch hoch
y = Timer                                       ' setzt X auf Timer, Timer zhlt automatisch hoch
#schleife1
if Timer = x then tmp = 215                     ' LED abdunkeln 1. Schritt
pwm1 tmp
if Timer = x + 2 then tmp = 190                 ' LED abdunkeln 2. Schritt
pwm1 tmp
if Timer = x + 4 then tmp = 155                 ' LED abdunkeln 3. Schritt
pwm1 tmp
if Timer = x + 8 then tmp = 120                 ' LED abdunkeln 4. Schritt
pwm1 tmp
if Timer = x + 10 then tmp = 95                 ' LED abdunkeln 5. Schritt
pwm1 tmp
if Timer = x + 12 then tmp = 60                 ' LED abdunkeln 6. Schritt
pwm1 tmp
if Timer = x + 14 then tmp = 95                 ' LED abdunkeln 1. Schritt
pwm1 tmp
if Timer = x + 16 then tmp = 120                ' LED abdunkeln 2. Schritt
pwm1 tmp
if Timer = x + 18 then tmp = 155                ' LED abdunkeln 3. Schritt
pwm1 tmp
if Timer = x + 20 then tmp = 190                ' LED abdunkeln 4. Schritt
pwm1 tmp
if Timer = x + 22 then tmp = 215                ' LED abdunkeln 5. Schritt
pwm1 tmp
if Timer = x + 24 then tmp = 250                ' LED abdunkeln 6. Schritt
pwm1 tmp
if Timer = x + 26 then x = timer                ' 1. Timer Neustart
if Timer = y + 52 then goto weiter2             ' 2. Timer zhlt hoch - Dauer der Umlufe
goto schleife1                                  ' sind nicht alle Durchlufe absolviert, dann von vorn
#weiter2
  a = off
  b = off
  c = off
  d = off
  e = off
  f = off
  g = off
RETURN
End FUNC
'--------------------------------------------------------------------------------------

'--- Licht an --------------------------------------------------------------------------
' der Dezimalpunkt leuchtet und das Relais wird angesteuert
'--------------------
FUNC Licht_on
  dp = on                                       ' Dezimalpunkt leuchtet
  Relais = on                                   ' Lichtrelais ansteuern
  RETURN
END FUNC
'---------------------------------------------------------------------------------------
'--- Licht aus --------------------------------------------------------------------------
' der Dezimalpunkt aus und das Relais aus
'--------------------
FUNC Licht_off
  dp = off                                      ' Dezimalpunkt aus
  Relais = off                                  ' Lichtrelais ausschalten
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'--- Schaltblitz Tag-----------------------------------------------------------------------
Func Blitztag
  Schaltblitz = on
  pause 20                                      ' Blitz fr 0,4 Sekunden aktiv
  Schaltblitz = off
  Return
End FUNC

'--- Schaltblitz Nacht -----------------------------------------------------------------------
Func Blitznacht
  Schaltblitz = on
  pause 4                                       ' Blitz fr 0,08 Sekunden aktiv
  Schaltblitz = off
  Return
End FUNC

end                                             ' Programmende

' ---------------------------------------------------------------------------
' --- PWM-Routinen fr Port1 ------------------------------------------------
' ---------------------------------------------------------------------------
TABLE pwm1_ein byte                                                          ' PWM Port1 einschalten
  &h12 &h06
  &h1a &h20 &h18 &h20 &h3f &h26 &h3f &h27 &ha6 &h1a &hb7 &h25 &h1b &h20 &h81
TABEND
' ---------------------------------------------------------------------------
TABLE pwm1 byte                                                              ' PWM Port1 setzten - Uebergabe als Argument
  &h12 &h06
  &had &h13 &ha1 &hfa &h25 &h03 &h10 &h25 &h81 &h5f &h48 &h59 &h48 &h59 &hbf &h26
  &hb7 &h27 &h11 &h25 &h81 &hae &h01 &h83
TABEND
' ---------------------------------------------------------------------------
TABLE pwm1_aus byte                                                          ' PWM Port1 ausschalten
  &h12 &h06
  &h1a &h20 &h18 &h20 &h3f &h25 &h1b &h20 &h81
TABEND
' ---------------------------------------------------------------------------

'*** Beschreibung **************************************************************************************
'--- Spannungsmessung Gangsensor ---
'Die GA-V3 speist exakt 5 Volt an den Gangsensor.
'Damit wird die Messspannung niemals ber 5 Volt liegen. Bei offenem Gangsensor (Leerlauf) wird durch einen Pullup-Widerstand
'in der GA-V3 die Spannung auf 5 Volt gezogen. 5 Volt entsprechen damit immer Leerlauf
'Die Spannung wird in 0,02 Volt Schritten aufgelst. Die Variable geht also bis maximal 250.
'Die Abfrage der Gnge wird nur jeden dritten Programmumlauf vollzogen. Alle Gnge beinhalten eine Dreifachabfrage des Ereignisses "Gangschaltung"
'Damit wird die Unsicherheit des Sensorschalters abgefangen um eine stabile Anzeige zu bekommen. 60 ms x 60ms = 360 ms Umschaltzeit bei Gangwechsel.

'--- Freq ----
'Mit dieser internen Variable kann die Frequenz am FREQ-Pin (PORT[3]) abgefragt werden.
'Die Messung erfolgt im Hintergrund, parallel zur Programmausfhrung. Die Frequenzmessung
'wird erst aktiviert, nachdem die Torzeit (Mezeit) eingestellt wurde. 
'Die Torzeit wird in 20-ms-Schritten angegeben und wird erst nach Ablauf der vorherigen wirksam.
'Durch "FREQ=0" oder "FREQ=OFF" lt sich die Frequenzmessung deaktivieren. Whrend BEEP, GET, INPUT
'und SLOWMODE werden alle Interrupts deaktiviert und deshalb wird auch FREQ nicht mehr aktualisiert.
'Zurckgeliefert wird die Anzahl der innerhalb der Mezeit aufgetretenen Impulse. Und zwar wird bei
'jeder fallenden Flanke am KBI2-Pin (liegt am gleichen Pin wie PORT[3]) ein Interrupt ausgelst.
'Die Frequenz, gezhlt in Impulse pro Sekunde, lt sich daraus berechnen zu

     ' f = FREQ / MESSZEIT.

'Achtung: Nach einem Reset mu PORT[3] auf High-Potential (5 Volt) liegen, sonst geht der Kontroller
'in den Hostmodus und arbeitet das BASIC-Programm nicht ab.


'---Verfgbarkeit----
'Open-Micro: an PORT[3]
'Open-Mini:  an PORT[3]
'Open-Midi:  an PORT[3]

'---Syntax----
'FREQ
'FREQ1

'---Beispiel----
'FREQ = 3    'Torzeit, bzw. Mezeit: 0,06 Sekunden

'gemessen - 11,5 Hz Leerlauf ungefhr 700 Umdrehungen/min -> mal 22 wegen 22 Impulsen je Umdrehung
'Also 700/60*22 = 256 Hz - Dann Multiplikation mit Torzeit fr Schaltblitzschwellen

'Version mit Kurbelwellensignal - 21 Impulse je Umdrehung
'Torzeit 0,06 Sekunden  - 700 Umdrehungen fr Einschalten Licht= 11,5 U/sekunde*21= 256 Impulse * 0,06 = 15
'Torzeit 0,06 Sekunden  - 10200 Umdrehungen fr Einschalten Blitz= 170 U/sekunde*21= 3740 Impulse * 0,06 = 214
